open (FI,"<data.db");
open (FO,">appendix_hotkeys.xml");

$icons->{1} = "b3ds.png";
$icons->{2} = "bIpos.png";
$icons->{3} = "bSeqs.png";
$icons->{4} = "bImas.png";
$icons->{5} = "TextEdit.png";
$icons->{6} = "kObj.png";
$icons->{7} = "kMesh.png";
$icons->{8} = "kOM.png";
$icons->{9} = "Pose.png";
$icons->{10} = "ObOrient.png";
$icons->{11} = "Render.png";

$where->{1} = "bSel.png";
$where->{2} = "bTri.png";
$where->{3} = "bKeySel.png";
$where->{4} = "bSeqSel.png";
$where->{5} = "bButs.png";
$where->{6} = "bSelMesh.png";
$where->{7} = "bCurve.png";
$where->{8} = "bIpoSel.png";
$where->{9} = "Render.png";
$where->{10} = "armSel.png";
$where->{11} = "bImas.png";
$where->{12} = "kOM.png";

$where->{20} = "kPop.png";
$where->{21} = "kAdd.png";
$where->{22} = "bFile.png";
$where->{23} = "mL.png";
$where->{24} = "mR.png";

print FO "<!-- Appendix: Hotkeys -->\n";
print FO "<appendix id='appendix_hotkeys'>\n";
print FO "	<title>Hotkeys Reference</title>\n";

print FO "<para>This Appendix is an automated import of orijinal Joeri Kassenaar work, re-organized ";
print FO "as a text database by Bastian Salmela.</para>\n";

print FO "  <section><title>Symbols</title>\n";
print FO "<informaltable frame='all'>\n".
         "<tgroup cols='6' align='left' colsep='1' rowsep='1'>\n".
	  "<colspec colname='c1' colwidth='0.3in'/>\n".
	  "<colspec colname='c2' colwidth='1.2in'/>\n".
	  "<colspec colname='c3' colwidth='0.3in'/>\n".
	  "<colspec colname='c4' colwidth='1.2in'/>\n".
	  "<colspec colname='c5' colwidth='0.3in'/>\n".
	  "<colspec colname='c6' colwidth='1.2in'/>\n".
	  "<thead><row>\n".
          "<entry namest=\"c1\" nameend=\"c2\" align=\"center\">Works In</entry>\n".
          "<entry namest=\"c3\" nameend=\"c4\" align=\"center\">Works If</entry>\n".
          "<entry namest=\"c5\" nameend=\"c6\" align=\"center\">Causes</entry>\n".
          "</row></thead><tbody>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$icons->{1}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>3D Window</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$where->{1}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>An Object is selected</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$where->{20}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>A Menu to Appear</para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$icons->{2}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>IPO Window</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$where->{2}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Mesh Vertex/vertices is/are selected</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$where->{21}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>A Toolbox to Appear</para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$icons->{2}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Sequence Window</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$where->{3}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>IPO keys are selected</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$where->{22}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>A File Select dialog</para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$icons->{4}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Image Select Window</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$where->{4}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Sequence Strip is selected</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<para></para>";
print FO  "</entry>\n<entry><para>A Menu to Appear</para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$icons->{5}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Text Edit Window</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$where->{5}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>To be on a Button Window</para></entry>\n";
print FO  "<entry namest=\"c5\" nameend=\"c6\" align=\"center\">";
print FO  "<para><command>Uses</command></para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$icons->{6}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Object Mode</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$where->{6}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Data Selected</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$where->{23}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para><keycap>LMB</keycap></para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$icons->{7}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Edit Modes</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$where->{7}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>A Curve is selected</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$where->{24}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para><keycap>LMB</keycap></para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$icons->{8}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Object or Edit Modes</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$where->{8}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>IPO Handles selected</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<para></para>";
print FO  "</entry>\n<entry><para></para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$icons->{9}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Pose Mode</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$where->{9}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>A Render Window exists</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<para></para>";
print FO  "</entry>\n<entry><para></para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$icons->{10}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Object Oriented Window</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$where->{10}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>An Armature is selected</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<para></para>";
print FO  "</entry>\n<entry><para></para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$icons->{11}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Render Window</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$where->{11}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>An Object is selectedAn Image Select Window Exists</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<para></para>";
print FO  "</entry>\n<entry><para></para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<para></para>";
print FO  "</entry>\n<entry><para></para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"gfx/appendix_hotkeys/".$where->{12}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>In Object Mode</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<para></para>";
print FO  "</entry>\n<entry><para></para></entry>\n</row>\n";

print FO "  </tbody></tgroup></informaltable></section>\n\n\n";

$intable=0;
while(<FI>) {
  chomp();
  s/\&/\&amp;/;
  if (/^\[(.*)\]/) {
    print FO "  <section><title>$1</title>\n";
    print FO "<informaltable frame='all'>\n".
          "<tgroup cols='4' align='left' colsep='1' rowsep='1'>\n".
	  "<colspec colname='c1'/>\n".
	  "<colspec colname='c2'/>\n".
	  "<colspec colname='c3'/>\n".
	  "<colspec colname='c4'/>\n".
	  "<thead><row>\n".
          "<entry align=\"center\">Key</entry>\n".
          "<entry align=\"center\">Works in</entry>\n".
          "<entry align=\"center\">Action</entry>\n".
          "<entry align=\"center\">Works if</entry>\n".
	  "</row></thead><tbody>\n";
    $intable = 1;
  } else {
    if (length($_)<2) {
      if ($intable==1) {
	print FO "  </tbody></tgroup></informaltable></section>\n\n\n";
	$intable=0;
      }
    } else {
      ($K,$on,$desc,$req) = split(/\|/);
      $K =~ s/a/ALT/;
      $K =~ s/c/CTRL/;
      $K =~ s/s/SHIFT/;
      $K =~ s/\[(.)mb\]/$1MB/;
      if (length($K)==1) {
	$K = $K."KEY";
      }
      print FO "<row><entry align=\"center\"><keycap>$K</keycap></entry>\n";
      $on =~ s/ //g;
      @icons = split(/\,/,$on);
      print FO "<entry align=\"center\">";
      foreach $i (@icons) {
	print FO "<guiicon>".
	  "<inlinegraphic fileref=\"gfx/appendix_hotkeys/".
	    $icons->{$i}.
	      "\"></inlinegraphic></guiicon>";
      }
      print FO "</entry>\n";
      print FO "<entry align=\"center\"><para>$desc</para></entry>\n";
      $req =~ s/ //g;
      @icons = split(/\,/,$req);
      print FO "<entry align=\"center\">";
      foreach $i (@icons) {
	print FO "<guiicon>".
	  "<inlinegraphic fileref=\"gfx/appendix_hotkeys/".
	    $where->{$i}.
	      "\"></inlinegraphic></guiicon>";
      }
      print FO "</entry></row>\n";
    }
  }
}


print FO "</appendix>";
close(FO);
close(FI);
